
ISIS - Bug #1028

The Sensor class methods for computing phase, incidence, and emission angle are all incorrect

except for spheres.

2012-07-31 07:01 PM - Debbie Cook

Status: Acknowledged   

Priority: Normal   

Assignee:    

Category: API   

Target version: 3.4.11 (FY16 R1 2015-10-28 Oct)   

Impact:  Software Version:  

Description

The methods for computing phase, incidence, and emission angle in the Sensor class are incorrectly using the vector from the center

of the body to the surface point as the normal vector.  This vector is only normal if the target body is a sphere. See the Naif routine,

surfnm.c, to see how to calculate the normal for an ellipsoid.  

Note:: At the time of this posting the code for computing these angles is in the Sensor class.  A new class, EllipsoidShape, is under

construction, and it will eventually contain these methods.

The shape classes have been completed. See ShapeModel::calculateEllipsoidalSurfaceNormal() for the incorrect code.

History

#2 - 2013-08-15 10:41 AM - Anonymous

- Target version deleted (150)

#6 - 2015-07-23 10:08 AM - Kristin Berry

Stuart has the algorithm.

#7 - 2015-08-12 11:38 PM - Kristin Berry

- Target version set to 3.4.11 (FY16 R1 2015-10-28 Oct)

#8 - 2016-07-26 10:37 AM - Jean Backer

The EllipsoidShape class now exists and has methods calculateDefaultNormal(), calculateSurfaceNormal() and calculateLocalNormal().

The first two call calculateEllipsoidalSurfaceNormal() from the parent class (ShapeModel). This method calculates the ellipsoid normal by subtracting

spacecraft position from the surface point position. This is only the surface normal if the shape is spherical.

The third method in EllipsoidShape (calculateLocalNormal) calculates the norm using NAIF's surfnm routine. This routine takes the triaxial radii values

and the surface point position to find the correct normal for an ellipsoid.

It appears as though there should be a single method for the ellipsoid that uses the surfnm routine.

Note: When using an ellipsoidal shape model, the emission angle and local emission angle should be identical. However, calculateDefaultNormal() is

used to get the emission angle and calculateLocalNormal() is used to get the local emission angle and these values do not match if the body is not

spherical. You can use Enceladus test data to see the difference. (See Tammy Becker)
#9 - 2016-07-26 11:31 AM - Tammy Becker

A test image of Cassini ISS-Wide Angle (Enceladus):

/work/projects/isis/latest/data/m01028/W1487302209_2.cub

#10 - 2016-11-18 06:18 AM - Stuart Sides

This is a serious incorrect output.

#11 - 2016-11-18 06:24 AM - Stuart Sides

- Description updated
